import { DependencyInfo, ILifetime } from '../Lifetime';
import { Key, Selector } from '../ServiceCollection';
import { IServiceProvider } from './IServiceProvider';
export declare type ProviderScope = Record<Key<any>, any>;
export declare class ScopedContext<E = any> implements IServiceProvider<E> {
    private readonly singletons;
    private readonly lookup;
    private readonly ordered;
    readonly lifetimes: Record<Key<E>, ILifetime<any, E>>;
    readonly proxy: E;
    readonly scope: ProviderScope;
    constructor(parent: IServiceProvider<E>);
    get depth(): number;
    get lastSingleton(): DependencyInfo<E> | undefined;
    enter(lifetime: DependencyInfo): void;
    leave(lifetime: DependencyInfo): void;
    provide<T>(selector: Selector<T, E>): T;
    private getLifetime;
}
